#!/bin/sh

## 063h just checks for highest temp?_input figure in /sys/class/hwmon
BT="0"
TMP=~/.config/pmcputemp
arch=`uname -m`
load_module_func() {
	lsmod|grep -q coretemp
	CT=$?
	lsmod|grep -q k*temp
	KT=$?
	lsmod|grep -q it87
	IT=$?
	lsmod|grep -q lm85
	LT=$?
	lsmod|grep -q nct6775
	NT=$?
	lsmod|grep -q smsc47b397
	ST=$?
	if [ "$CT" = "1" ] && [ "$KT" = "1" ] && [ "$IT" = "1" ] && [ "$LT" = "1" ] && [ "$NT" = "1" ] && [ "$ST" = "1" ];then
		for m in coretemp k10temp k8temp it87 lm85 nct6775 smsc47b397
		do modprobe $m 2>/dev/null
			if [ "$?" = "0" ];then
				echo "loading $m"
				L=0
				break 
			else 
				L=1
				continue
			fi
		done
	[ "$L" = "1" ] && echo "Can't load a temperature module" && return 1
	fi
HD="/sys/class/hwmon/hwmon"
  for a in {0..7}
    do
      for b in {0..7}
        do
	  TL=$HD$a"/temp"$b"_input"
	  if [ -f "$TL" ];then
		TT=$( cat $TL )
		if [ $TT -gt $BT ];then BT=$TT ; TF=$TL ;fi
	  fi
	done
    done
  return 0
}

cputempfunc() {
	if [ "${arch:0:3}" != "arm" ];then
		load_module_func
		[ $? -ne 0 ] && exit 1
	fi
	[ ! -d $TMP ] && mkdir $TMP
	echo -n $TF > $TMP/pmcputemprc
}
cputempfunc
